/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012 by Meika Sugimoto
 *  Copyright (C) 2013-2015 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

/*
 * åȰ¸֥LPCXPRESSO-LPC812ѡ
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val)			(val)
#define ULONG_C(val)		(val)
#include "kernel_impl.h"
#include "lpcxpresso_lpc812.h"

/*
 * ٥ΥåȰ¸ν
 *
 * ˸ƤӽФ
 */
	.globl	hardware_init_hook

	.text
	.align 2
	.syntax unified
	.code 16
	.thumb
	.type hardware_init_hook, function
hardware_init_hook:
	// SWM, IOCON ΥåON
	ldr 	r3, .L6+4	// TADR_SYSAHBCLKCTRL
	ldr 	r1, .L6+8	// TVALUE_SYSAHBCLKCTRL
	ldr 	r2, [r3]
	orrs	r2, r2, r1
	str 	r2, [r3]

#ifdef USE_SYSTEM_PLL
#ifdef USE_EXTERNAL_OSCILLATOR
	// PIO0_8, PIO0_9 
	ldr 	r3, .L6+16	// TADR_IOCON_BASE

	movs 	r1, #TBITPTN_IOCON_PIOx_MODE
	mvns	r1, r1
	ldr 	r2, [r3, #TOFFSET_IOCON_PIO0_8]
	ands	r2, r2, r1
	str 	r2, [r3, #TOFFSET_IOCON_PIO0_8]

	ldr 	r2, [r3, #TOFFSET_IOCON_PIO0_9]
	ands	r2, r2, r1
	str 	r2, [r3, #TOFFSET_IOCON_PIO0_9]

	// XTALIN, XTALOUT üҤͭ
	ldr 	r3, .L6+20	// TADR_PINENABLE0
	movs 	r1, #(TBITPTN_SWM_PINENABLE0_XTALINEN | TBITPTN_SWM_PINENABLE0_XTALOUTEN)
	mvns	r1, r1
	ldr 	r2, [r3]
	ands	r2, r2, r1
	str 	r2, [r3]

	// 徽ȯ power on
	ldr 	r3, .L6+12	// TADR_PDRUNCFG
	movs 	r1, #TBITPTN_SYSCON_PDRUNCFG_SYSOSCPD
	mvns	r1, r1
	ldr 	r2, [r3]
	ands	r2, r2, r1
	str 	r2, [r3]

	// ƥ४졼
	ldr 	r3, .L6	// TADR_SYSCON_BASE
	movs	r2, #TVALUE_SYSCON_SYSOSCCTRL
	str 	r2, [r3, #TOFFSET_SYSCON_SYSOSCCTRL]

	// äԤ
	movs	r1, #0
.L1:
	str     r1, [sp, #4]
	cmp     r1, #199
	bhi     .L2
	nop
	adds     r1, #1
	b       .L1
#endif /* USE_EXTERNAL_OSCILLATOR */

.L2:
	// System PLL å (XTALޤIRC졼)
	ldr 	r3, .L6	// TADR_SYSCON_BASE
	movs	r2, #TVALUE_SYSCON_SYSPLLCLKSEL
	str 	r2, [r3, #TOFFSET_SYSCON_SYSPLLCLKSEL]

	// åι
	movs	r2, #TBITPTN_SYSCON_SYSPLLCLKUEN_ENA
	str 	r2, [r3, #TOFFSET_SYSCON_SYSPLLCLKUEN]

	// ޤԤ
.L3:
	ldr 	r1, [r3, #TOFFSET_SYSCON_SYSPLLCLKUEN]
	ands	r1, r2  	// r1 <-- r1(=SYSPLLCLKUEN) & r2(=TBITPTN_SYSPLLCLKUEN_ENA)
	beq 	.L3     	// if(r1 == 0) goto .L3

	// PLLΨ
	movs	r2, #TVALUE_SYSCON_SYSPLLCTRL
	str 	r2, [r3, #TOFFSET_SYSCON_SYSPLLCTRL]

	// System PLL ŸON
	ldr 	r3, .L6+12	// TADR_PDRUNCFG
	movs 	r1, #TBITPTN_SYSCON_PDRUNCFG_SYSPLLPD
	mvns	r1, r1
	ldr 	r2, [r3]
	ands	r2, r2, r1
	str 	r2, [r3]

	// PLLåԤ
	ldr 	r3, .L6	// TADR_SYSCON_BASE
	movs	r2, #TBITPTN_SYSCON_SYSPLLSTAT_LOCK
.L4:
	ldr 	r1, [r3, #TOFFSET_SYSCON_SYSPLLSTAT]
	ands	r1, r2  	// r1 <-- r1(=SYSPLLSTAT) & r2(=TBITPTN_SYSPLLSTAT_LOCK)
	beq 	.L4         // if(r1 == 0) goto .L4
#endif /* USE_SYSTEM_PLL */

	// ᥤ󥯥åϤ
	ldr 	r3, .L6	// TADR_SYSCON_BASE
	movs	r2, #TVALUE_SYSCON_MAINCLKSEL
	str 	r2, [r3, #TOFFSET_SYSCON_MAINCLKSEL]

	// ᥤ󥯥åι
	movs	r2, #TBITPTN_SYSCON_MAINCLKUEN_ENA
	str 	r2, [r3, #TOFFSET_SYSCON_MAINCLKUEN]

	// ޤԤ
.L5:
	ldr 	r1, [r3, #TOFFSET_SYSCON_MAINCLKUEN]
	ands	r1, r2	// r1 <-- r1(=MAINCLKUEN) & r2(=TBITPTN_MAINCLKUEN_ENA)
	beq 	.L5   	// if(r1 == 0) goto .L5

	// ƥ९åʬ
	movs	r2, #TVALUE_SYSCON_SYSAHBCLKDIV
	str 	r2, [r3, #TOFFSET_SYSCON_SYSAHBCLKDIV]

	// ȥ졼å(ɬפʤ顥Not Yet)

	bx	lr

	.align 2
.L6:
	.word	TADR_SYSCON_BASE
	.word	TADR_SYSCON_SYSAHBCLKCTRL
	.word	TVALUE_SYSCON_SYSAHBCLKCTRL
	.word	TADR_SYSCON_PDRUNCFG
	.word	TADR_IOCON_BASE
	.word	TADR_SWM_PINENABLE0
